<!-- 
 * @Description: 寝室管理
 * @Author: syy 
 * @Date: 2024-7-15
-->
<template>
  <div class="main-box">
    <TreeFilter
      ref="treeFilter"
      title="宿舍楼管理"
      label="name"
      id="id"
      width="300px"
      :show-all="true"
      :request-api="userManageDormitoryApi.list"
      @change="changeTreeFilter"
    >
      <template v-slot:header>
        <s-button suffix="宿舍楼" @click="addDormitory(FormOptEnum.ADD)" style="margin-bottom: 15px" />
      </template>
      <template v-slot:label="{ row }">
        <span class="custom-tree-node">
          <span>{{ row.node.data.name }}</span>
          <span v-if="row.node.data.id != ''">
            <a :title="FormOptEnum.EDIT" @click.stop="addDormitory(FormOptEnum.EDIT, row.node.data)">
              <el-icon><Edit /></el-icon>
            </a>
            <a :title="FormOptEnum.DELETE" style="margin-left: 8px" @click.stop="addDelete(row.node.data.id, '删除宿舍楼')">
              <el-icon><Delete /></el-icon>
            </a>
          </span>
        </span>
      </template>
    </TreeFilter>
    <div class="table-box">
      <ProTable ref="proTable" title="寝室管理" :columns="columns" rowKey="id" :request-api="userManageDormitoryApi.page">
        <!-- 表格 header 按钮 -->
        <template #tableHeader="scope">
          <s-button v-auth="dormitoryButtonCode.add" suffix="寝室" @click="onOpen(FormOptEnum.ADD, { buildId: buildId, gender: buildGender })" />
          <s-button
            v-auth="dormitoryButtonCode.delete"
            type="danger"
            :opt="FormOptEnum.DELETE"
            plain
            suffix="寝室"
            :disabled="!scope.isSelected"
            @click="onDelete(scope.selectedListIds, '删除所选寝室')"
          />
        </template>
        <!-- 表格操作栏 -->
        <template #operation="scope">
          <el-space>
            <s-button v-auth="dormitoryButtonCode.edit" link :opt="FormOptEnum.EDIT" @click="onOpen(FormOptEnum.EDIT, scope.row)" />
            <s-button v-auth="dormitoryButtonCode.delete" link :opt="FormOptEnum.DELETE" @click="onDelete([scope.row.id], `删除寝室`)" />
            <el-dropdown @command="handleCommand">
              <el-link type="primary" :underline="false" :icon="ArrowDown"> 更多 </el-link>
              <template #dropdown>
                <el-dropdown-menu>
                  <el-dropdown-item :command="command(scope.row, cmdEnum.AddPerson)">
                    {{ cmdEnum.AddPerson }}
                  </el-dropdown-item>
                </el-dropdown-menu>
              </template>
            </el-dropdown>
          </el-space>
        </template>
      </ProTable>
    </div>
    <!-- 寝室新增/编辑表单 -->
    <Form ref="formRef"></Form>
    <!-- 宿舍楼新增/编辑表单 -->
    <FormDormitory ref="formRefD" />
    <!-- 班主任绑定/修改 -->
    <!--  :user-selector-params="{ orgId: orgId }" -->
    <ClassUserselector
      ref="userSelectorRef"
      :org-tree-api="userManageClassManageApi.page"
      :org-tree-props="{ label: 'name', children: 'children' }"
      :user-selector-api="userManagePersonnelApi.page"
      multiple
      @successful="handleChooseUser"
    >
    </ClassUserselector>
    <!-- <formUser ref="formRefU" /> -->
    <!-- 预览头像 -->
    <el-dialog v-model="visible" title="查看头像" width="830px" :before-close="handleClose">
      <div style="display: flex; align-items: center; justify-content: center">
        <img style="max-width: 100%; max-height: 600px" class="detailpic" :src="faceUrl" alt="" />
      </div>
    </el-dialog>
  </div>
</template>
<script setup lang="tsx" name="SysDormitory">
import { userManageDormitoryApi,dormitoryButtonCode,SysDormitory,sysOrgApi,sysPositionApi,sysUserApi,sysRoleApi,userManagePersonnelApi,userManageClassManageApi } from "@/api";
import { useHandleData } from "@/hooks/useHandleData";
import { FormOptEnum } from "@/enums";
import Form from "./components/form/index.vue";
import FormDormitory from "./components/formDormitory/index.vue";
import formUser from "./components/formUser/index.vue";
import { ArrowDown,More } from "@element-plus/icons-vue";
import { ColumnProps, ProTableInstance } from "@/components/ProTable/interface";
import TreeFilter from "@/components/TreeFilter/index.vue";
import { useUserStore } from "@/stores/modules";
import { TokenEnum } from "@/enums";
import type { UploadProps } from "element-plus";
import { UserSelectorInstance } from "@/components/Selectors/UserSelector/interface";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const faceUrl = ref('');
const visible = ref(false); //是否显示寝室表单
const proTable = ref<ProTableInstance>();
const treeFilter = ref<InstanceType<typeof TreeFilter> | null>(null);
const userStore = useUserStore();
const { accessToken } = userStore;
// 表格配置项
const columns: ColumnProps<SysDormitory.ChamberInfo>[] = [
  { type: "selection", fixed: "left", width: 50 },
  {
    prop: "name",
    label: "寝室名称"
  },
  {
    prop: "personCount",
    label: "人员数量"
  },
  {
    prop: "createTime",
    label: "创建时间"
  },
  { prop: "operation", label: "操作", width: 250, fixed: "right" }
];
const viewHeadImage = (scope: any) => {
  faceUrl.value = scope.row.faces[0].faceUrl;
  visible.value = true
  console.log(faceUrl);
};
const handleClose = () => {
  visible.value = false;
};
 function handleChooseUser(data: SysUser.SysUserInfo[]) {
  console.log(data)
  
   //组装参数
   const grantUser: SysRole.GrantUserReq = {
    // id: roleId.value,
    // grantInfoList: data.map(item => item.id) as number[] | string[],
    dormitoryId: chamberId.value,
    personIds: data.map(item => item.personId) as number[] | string[],
  };
  userManageDormitoryApi.setAssignPerson(grantUser);
}
// 寝室表单引用
const formRef = ref<InstanceType<typeof Form> | null>(null);
// 宿舍楼表单引用
const formRefD = ref<InstanceType<typeof FormDormitory> | null>(null);
// 人员引用
const formRefU = ref<InstanceType<typeof formUser> | null>(null);

/**
 * 打开表单
 * @param opt  操作类型
 * @param record  记录
 */
function onOpen(opt: FormOptEnum, record: {} | SysDormitory.ChamberInfo = {}) {
  if(buildId.value) {
    formRef.value?.onOpen({ opt: opt, record: record, successful: RefreshTable });
  } else {
    ElMessage({
      message: '请选择宿舍楼',
      type: 'warning'
    });
  }
  
}

/**
 * 打开宿舍楼表单
 * @param opt  操作类型
 * @param record  记录
 */

 function addDormitory(opt: FormOptEnum, record: {} | SysDormitory.DormitoryInfo = {}) {
  formRefD.value?.onOpen({ opt: opt, record: JSON.parse(JSON.stringify(record)), successful: RefreshTree });
}
/**
 * 宿舍楼删除
 * @param ids  id数组
 */
 async function addDelete(id: string[],msg: string) {
  // 二次确认 => 请求api => 刷新表格
  await useHandleData(userManageDormitoryApi.deleteDormitory, { id }, msg);
  RefreshTree(); //刷新表格
}

/**
 * 寝室删除
 * @param ids  id数组
 */
 async function onDelete(ids: string[], msg: string) {
  if(ids.length === 0){
    ElMessage({
      message: '请选择要删除的寝室',
      type: 'warning'
    });
    return
  }
  // 二次确认 => 请求api => 刷新表格
  await useHandleData(userManageDormitoryApi.delete, {id: ids.join(",") }, msg);
  RefreshTable(); //刷新表格
}

// 刷新表格
const RefreshTable = () => {
  proTable.value?.refresh();
}
// 同时刷新列表和树并恢复初始状态
const RefreshTree = () => {
  proTable.value!.pageable.pageNum = 1;
  proTable.value!.searchParam.buildId = null;
  proTable.value!.searchParam.gender =null;
  treeFilter.value?.refresh(); //刷新树形筛选器
  proTable.value!.search();
}


/** 更多下拉菜单命令枚举 */
enum cmdEnum {
  AddPerson = "添加人员",
}
/** 下拉菜单参数接口 */
interface Command {
  row: SysDormitory.ChamberInfo;
  command: cmdEnum;
}

/**配置command的参数 */
function command(row: SysDormitory.ChamberInfo, command: cmdEnum): Command {
  return {
    row: row,
    command: command
  };
}
/**
 * 列表更多下拉菜单点击事件
 * @param command
 */
 const userSelectorRef = ref<UserSelectorInstance>(); //用户选择器引用
const chamberId = ref<number | string>(); //寝室id
function handleCommand(command: Command) {
  switch (command.command) {
    case cmdEnum.AddPerson:
      console.log(111)
      // addPerson(FormOptEnum.add, command.row)
      userSelectorRef.value?.showSelector(); //显示用户选择器
      chamberId.value = command.row.id; //获取寝室id
      break;
  }
}
function addPerson(opt: FormOptEnum, record: {} | SysDormitory.DormitoryInfo = {}) {
  formRefU.value?.onOpen({ opt: opt, record: record, successful: RefreshTable });
}
/** 宿舍楼切换 */
const buildId = ref<number | string>()
const buildGender = ref<boolean>()
function changeTreeFilter(val: number | string, data: any) {
  buildId.value = data.id;
  buildGender.value = data.gender;
  proTable.value!.pageable.pageNum = 1;
  proTable.value!.searchParam.buildId = data.id;
  proTable.value!.searchParam.gender = data.gender;
  proTable.value!.search();
}
</script>
<style scoped lang="scss">
.table-box {
  width: 100%;
  height: 100%;
}
.custom-tree-node {
  display: flex;
  flex: 1;
  align-items: center;
  justify-content: space-between;
  padding-right: 8px;
  font-size: 14px;
}
</style>
